
    case 'access': 
      $type = $arg0;
      $account = &$arg1;
      $object = &$arg2;
      // For events we check that node and comment are allowed
	  drupal_set_message('access script');
      if ($type == 'event') {        
 	  drupal_set_message('access granted');
           $access = TRUE;
  
      }
      return array($access);      
      break;



/**
 * Implementation of hook_nodeapi()  Store all event nodes in notifications table
 */
function notifications_event_nodeapi(&$node, $op, $arg = 0) {
  global $user;
  if($node->type == "event") {
    switch ($op) {
      case 'update':
        if ($node->status == '0') { // unpublished
          break; // don't notify
        }
      
      // prevent already published edits from sending notifications
      // @ TODO send nodes that have been updated could be controlled here
        if ($node->status == 1 && $node->notifications_currentstatus == '1') {
          break;
        }
      //
      // else, fall through

      case 'insert':
        // get event start date
        $event = array(
          'module' => 'node',
          'uid' => $node->uid,
          'oid' => $node->nid,
          'type' => 'node',
          'action' => $op,
          'node' => $node,
          'params' => array('nid' => $node->nid, 'event_start => $node->event_start),      
        );
        notifications_event1($event);
        break;
      case 'delete':
        // Remove all subscriptions for this node
        notifications_delete_subscriptions(array('event_type' => 'node'), array('nid' => $node->nid));
	}
  }
}







   case 'event queued':
   // Custom query for notifications_event
    
    // We throw in all the conditions and check the number of matching conditions
    // that must be equal to the subscription conditions number
    $sql = 'INSERT INTO {notifications_queue} (uid, sid, module, eid, send_interval, send_method, cron, created, conditions) '.
      'SELECT DISTINCT s.uid, s.sid, s.module, %d, s.send_interval, s.send_method, s.cron, %d, s.conditions '.
      'FROM {notifications} s INNER JOIN {notifications_fields} f ON s.sid = f.sid '.
      implode(' ', $query['join']);
    $sql .=  " WHERE s.status = 1 AND s.event_type = '%s' AND ((". implode(') OR (', $query['where']) .')) ';
    // Add one more condition if we don't send notifications on own posts
    if (!variable_get('notifications_sendself', 0)) {
      $sql .= 'AND s.uid != %d ';
      $query['args'][] = $event->uid;
    }
    // Some group by fields are not really needed but added for pgsql compatibility
    $sql .=  'GROUP BY s.uid, s.sid, s.module, s.send_interval, s.send_method, s.cron, s.conditions HAVING s.conditions = count(f.sid)';
    db_query($sql, $query['args']);
    break;
  // load content for cron generated email
   case 'event load': // $arg0 is event
      $event = &$arg0;
      $load = array();
      if ($event->type == 'node') {
        if (!empty($event->params['nid'])) {
          $event->objects['node'] = node_load($event->params['nid']);
        }
      }
      break;

	  
  case 'names':
      $subs = &$arg0;
      if ($subs->event_type == 'node') {
        $subs->type_name = t('Content');
        if (!empty($subs->fields['type'])) {
          $subs->names['type'] = t('Content type: %type', array('%type' => node_get_types('name', $subs->fields['type'])));
        }
        if (!empty($subs->fields['author']) && ($author = user_load(array('uid' => $subs->fields['author'])))) {
          $subs->names['author'] = t('Author: %name', array('%name' => $author->name));
        }
        if (!empty($subs->fields['nid']) && ($node = node_load($subs->fields['nid']))) {
          $subs->names['thread'] = t('Thread: %title', array('%title' => $node->title));
        }
      }
      break;
    case 'subscription types':
      $types['thread'] = array(
        'event_type' => 'node',
        'title' => t('Thread'),
        'access' => 'subscribe to content',
        'page' => 'notifications_content_page_thread',
        'fields' => array('nid'),
      );
      $types['nodetype'] = array(
        'event_type' => 'node',
        'title' => t('Content type'),
        'access' => 'subscribe to content type',
        'page' => 'notifications_content_page_nodetype',
        'fields' => array('type'),
      );
      $types['author'] = array(
        'event_type' => 'node',
        'title' => t('Author'),
        'access' => 'subscribe to author',
        'page' => 'notifications_content_page_author',
        'fields' => array('author'),
      );
      return $types;
 
    case 'node options':
      return _notifications_content_node_options($arg0, $arg1);
    case 'event load': // $arg0 is event
      $event = &$arg0;
      $load = array();
      if ($event->type == 'node') {
        if (!empty($event->params['nid'])) {
          $event->objects['node'] = node_load($event->params['nid']);
        }
        if (!empty($event->params['cid'])) {
          $event->objects['comment'] = notifications_content_comment_load($event->params['cid']);
        }
      }
      break;
    case 'event types':
      // Node inserts are not grouped by node but all together. The digest will look like:
      //   New content has been submitted
      //   - Story Title1 by Author1
      //   - Event Title2 by Author2
      $types[] = array(
        'type' => 'node',
        'action' => 'insert',
        'name' => 'New content of type [type-name] has been submitted',
        'line' => '[type-name] [title] by [author-name]',
        'digest' => array('node', 'type'),
      );
      // These other events are grouped for each node. The digest will look like:
      //   Story: Title of the story
      //   - The story has been updated
      //   - New comment by User: Comment title
      $types[] = array(
        'type' => 'node',
        'action' => 'update',
        'name' => '[type-name]: [title]',
        'line' => 'The [node-type] has been updated',
        'digest' => array('node', 'nid'), 
      );      
      $types[] = array(
        'type' => 'node',
        'action' => 'comment',
        'name' => '[type-name]: [title]',
        'line' => 'New comment by [comment-author-name]: [comment-title]', 
        'digest' => array('node', 'nid'),
      );
      return $types;
    
	// modify the queue
    case 'event queued': 
    return $stuff;

    case 'access': 
      $type = $arg0;
      $account = &$arg1;
      $object = &$arg2;
      $access = TRUE;
      // For events we check that node and comment are allowed
      if ($type == 'event' && $object->type == 'node') {        
        if (!empty($object->objects['node'])) {
          $access = notifications_content_node_allow($account, $object->objects['node']);
        }
        // If no access to node, we don't check more
        if ($access && !empty($object->objects['comment'])) {
          $access = $access && notifications_content_comment_allow($account, $object->objects['comment']);
        }
      // For node subscriptions we check that user can view the node
      }
      elseif ($type == 'subscription' && !empty($object->fields['nid'])) {
        if ($node = node_load($object->fields['nid'])) {
          $access =  notifications_content_node_allow($account, $node);
        }
        else {
          $access = FALSE;
        }
      }
      return array($access);      
      break;
